=== modified file 'src/com/goldencode/p2j/persist/BufferManager.java'
--- old/src/com/goldencode/p2j/persist/BufferManager.java	2022-07-07 16:14:44 +0000
+++ new/src/com/goldencode/p2j/persist/BufferManager.java	2022-09-06 18:22:04 +0000
@@ -444,6 +444,21 @@
 **                           were added to the collection during iterating it, resulting in a 
 **                           ConcurrentModificationException (refs #6356). 
 **     CA  20220707          Cache the converted Java names for the dynamic buffers.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
+**     CA  20220906          Removed state which is no longer used (PersistentProcScope.loadedBuffers and
+**                           undoData) and removed methods which are not being invoked.
+**                           Moved the parameter assigner scopeable support to AbstractParameter (as all 
+**                           parameters require scope support, not just fields).
+**                           Extracted all BufferManager state which requires notification for 
+**                           'isImportantBlock' to an external TxWrapper class (including the private class 
+**                           here), to allow the scopeable BufferManager state related only to buffers (and  
+**                           not transaction related) to be registered for scope notifications in a lazy 
+**                           manner, when buffers are accessed/used/opened.
 */
 
 /*
@@ -512,13 +527,12 @@
 import com.goldencode.p2j.oo.lang.*;
 import com.goldencode.p2j.persist.dirty.*;
 import com.goldencode.p2j.persist.id.*;
-import com.goldencode.p2j.persist.lock.*;
-import com.goldencode.p2j.persist.orm.*;
 import com.goldencode.p2j.security.*;
 import com.goldencode.p2j.util.*;
 import com.goldencode.p2j.util.LogHelper;
 import com.goldencode.p2j.util.ErrorManager;
 import com.goldencode.util.*;
+import com.goldencode.util.Stack;
 
 /**
  * Manages all record buffers within the current user context.  This includes
@@ -553,10 +567,8 @@
  */
 public final class BufferManager
 implements Scopeable,
-           Commitable,
            BatchListener,
-           StopConditionVetoHandler,
-           Resettable
+           StopConditionVetoHandler
 {
    /** Logger */
    private static final Logger LOG = LogHelper.getLogger(BufferManager.class.getName());
@@ -568,9 +580,6 @@
       @Override protected BufferManager initialValue() { return (new BufferManager()); }
    };
    
-   /** Flag indicating whether class was initialized, i.e. {@link #initialize} was called */
-   private static boolean initialized = false;
-   
    /** A cache of buffer-related fields defined in a specific legacy-converted class. */
    private static final Map<Class<?>, Set<Field>> classBufferFields = new ConcurrentHashMap<>();
    
@@ -578,15 +587,6 @@
    // intentionally package private for direct use from RecordBuffer
    final Map<BufferType, MutableInteger> changeScopes = new HashMap<>();
    
-   /** Transaction finalizable to manage transaction state locally (avoid context-local calls) */
-   private final Finalizable xactFin = new Finalizable()
-   {
-      @Override public void finished() { transactionDepth = -1; }
-      @Override public void deleted()  { }
-      @Override public void iterate()  { }
-      @Override public void retry()    { }
-   };
-   
    /** Finalizable which clears batch mode at the appropriate times */
    private final Finalizable batchCleaner = new Finalizable()
    {
@@ -595,10 +595,7 @@
       @Override public void iterate()  { RecordBuffer.cleanupBatchMode(BufferManager.this); }
       @Override public void retry()    { RecordBuffer.cleanupBatchMode(BufferManager.this); }
    };
-   
-   /** Field assigner for function/procedure parameter assign-backs */
-   private final Scopeable fieldScopes = FieldAssigner.getScopeable();
-   
+
    /** The buffers which will be registered on the next scope entry. */
    private final Set<RecordBuffer> pendingBuffers = Collections.newSetFromMap(new IdentityHashMap<>());
    
@@ -622,14 +619,6 @@
     */
    private final ScopedDictionary<Object, Map<String, RecordBuffer>> byLegacyName = new ScopedDictionary<>();
    
-   /**
-    * Scoped dictionary which key set contains all buffers into which a new record was loaded (or
-    * the old record was reloaded) into corresponding scopes. Value set doesn't contain any useful
-    * information and is used as a temporary data storage during copying from one scope level to
-    * another.
-    */
-   private final ScopedDictionary<RecordBuffer, Boolean> loadedBuffers = new ScopedDictionary<>();
-   
    /** Buffers whose scopes have been opened, but are not yet initialized */
    private final Map<RecordBuffer, Boolean> uninitializedOpenBuffers = new WeakHashMap<>();
    
@@ -637,13 +626,6 @@
    private final ScopedList<RecordBuffer> openBuffers = new ScopedList<>();
    
    /**
-    * The buffers touched via a Create, Update or Delete operation, in each scope. If the full transaction
-    * block is not {@link #commit committed} or {@link #rollback rolled back}, then the buffers will be merged 
-    * in the previous scope. 
-    */
-   private final TailScopedDictionary<RecordBuffer, Boolean> dirtyBuffers = new TailScopedDictionary<>();
-   
-   /**
     * Scoped dictionary which contains currently active static temp tables (i.e. table scope was
     * opened and not yet closed). Keyed by a {@code TempTableKey} compound from the legacy table
     * name and the procedure where the temp table was defined.
@@ -662,18 +644,12 @@
    private final ScopedDictionary<OutputTableHandleCopier, Integer> thOutputParameters =
       new ScopedDictionary<>();
    
-   /** Database to transaction wrapper instance map */
-   private final Map<Database, TxWrapper> txWrapperMap = new HashMap<>();
-   
-   /** Transaction wrappers not yet activated */
-   private final Map<Database, TxWrapper> inactiveTxWrappers = new HashMap<>();
+   /** Track the external scopes pushed on {@link BufferManager}. */
+   private final Stack<Boolean> externalScope = new Stack<>();
    
    /** Active persistence contexts (those which have an open database session) */
    private final Set<Persistence.Context> activePersistenceContexts = Collections.newSetFromMap(new IdentityHashMap<>());
    
-   /** All undoable actions scoped by block and keyed by buffer type */
-   private final ScopedDictionary<BufferType, UndoData> undoData = new ScopedDictionary<>();
-   
    /** Stack of batch mode data */
    private final ArrayDeque<BatchModeData> batchModeStack = new ArrayDeque<>();
    
@@ -686,30 +662,21 @@
    /** Helper to use the ProcedureManager without any context local lookups. */
    private final ProcedureManager.ProcedureHelper pm = ProcedureManager.getProcedureHelper();
    
-   /** Counter of in-use buffers for each database. */
-   private final Map<Database, MutableInteger> activeDatabases = new HashMap<>();
-   
    /** Transaction helper */
    private final TransactionManager.TransactionHelper txHelper;
    
-   /** Block depth at which full application transaction began, or -1 if not in a transaction */
-   private int transactionDepth = -1;
+   /** Tx wrapper helper. */
+   private TxWrapper.TxWrapperHelper txWrapperHelper;
+   
+   /** Change broker instance. */
+   private final ChangeBroker changeBroker;
    
    /** Connection manager */
    private ConnectionManager connMgr = null;
    
-   /** Context-local access to unique constraint tracker */
-   private UniqueTracker.Context uniqueTrackerCtx = UniqueTracker.getContext();
-   
    /** Number of nested queries being processed */
    private int queryDepth = 0;
    
-   /** Counter of the number of scope transitions (push or pop) */
-   private long scopeTransitions = 0L;
-   
-   /** Counter of the number of application-level transactions */
-   private long transactionCount = 0L;
-   
    /** Map of bound buffers to there destination, for each procedure. */
    private Map<TemporaryBuffer, Map<Object, Set<TemporaryBuffer>>> bindingBuffers = new IdentityHashMap<>();
    
@@ -732,15 +699,14 @@
    private BufferManager()
    {
       byLegacyName.setIdentityKeys(true);
-      loadedBuffers.setIdentityKeys(true);
-      dirtyBuffers.setIdentityKeys(true);
       thOutputParameters.setIdentityKeys(true);
       
       txHelper = TransactionManager.getTransactionHelper();
       
       txHelper.registerBatchListener(this);
       txHelper.registerStopVetoHandler(this);
-      txHelper.registerResettable(this);
+      
+      changeBroker = ChangeBroker.get();
       
       if (LOG.isLoggable(Level.FINE))
       {
@@ -749,22 +715,12 @@
    }
    
    /**
-    * Retrieve the context-local instance of this class, instantiating it
-    * first if necessary.
+    * Retrieve the context-local instance of this class, instantiating it first if necessary.
     *
     * @return  Context-local instance of this class.
-    * @throws  IllegalStateException
-    *            when {@link BufferManager} is not activated, i.e. {@link
-    *            #initialize()} is not called.
     */
    public static BufferManager get()
    {
-      if (!BufferManager.initialized)
-      {
-         throw new IllegalStateException(
-            "An attempt to use uninitialized BufferManager. Is persistence activated?");
-      }
-      
       BufferManager bm = context.get();
       if (bm.connMgr == null)
       {
@@ -779,10 +735,68 @@
             throw new RuntimeException("Multiple ConnectionManager in same context.");
          }
       }
+      
+      if (bm.txWrapperHelper == null)
+      {
+         bm.txWrapperHelper = TxWrapper.getHelper(bm);
+      }
+      
       return bm;
    }
    
    /**
+    * Register the {@link BufferManager} instance as for scope notifications at the current block.
+    * 
+    * @param    bufferManager
+    *           The {@link BufferManager} instance.
+    */
+   public static void registerScopeable(BufferManager bufferManager)
+   {
+      if (bufferManager == null)
+      {
+         bufferManager = get();
+      }
+      
+      // both ChangeBroker and BufferManager need to be added
+      bufferManager.txHelper.registerBlockScopeable(bufferManager);
+      bufferManager.txHelper.registerBlockScopeable(bufferManager.changeBroker);
+   }
+
+   /**
+    * Register the {@link BufferManager} instance as pending scopeable, to be added to the next block.
+    * 
+    * @param    bufferManager
+    *           The {@link BufferManager} instance.
+    */
+   public static void registerPendingScopeable(BufferManager bufferManager)
+   {
+      if (bufferManager == null)
+      {
+         bufferManager = get();
+      }
+      
+      // both ChangeBroker and BufferManager need to be added
+      bufferManager.txHelper.registerPendingScopeable(bufferManager);
+      bufferManager.txHelper.registerPendingScopeable(bufferManager.changeBroker);
+   }
+   
+   /**
+    * Register the {@link TxWrapper} scopeable as pending for the next opened block.
+    * 
+    * @param    bufferManager
+    *           The {@link BufferManager} instance.
+    */
+   public static void registerTxScopeable(BufferManager bufferManager)
+   {
+      if (bufferManager == null)
+      {
+         bufferManager = get();
+      }
+      
+      bufferManager.txWrapperHelper.registerPendingScopeable();
+   }
+   
+   /**
     * Cleanup of pending resources. This is called when the external procedure constructor failed 
     * to build a new object because of an exception thrown in a member initialization (shared 
     * frame/table).
@@ -794,21 +808,7 @@
       bm.pendingBufferClasses.clear();
       bm.pendingStaticTempTables.clear();
    }
-   
-   /**
-    * Register with the {@link com.goldencode.p2j.util.TransactionManager
-    * TransactionManager} a factory object which creates instances of this
-    * class, so that they can be registered to receive notifications of
-    * runtime scope start and finish events.
-    * <p>
-    * This method should be invoked once during the server bootstrap phase.
-    */
-   static void initialize()
-   {
-      TransactionManager.registerScopeableFactory(BufferManager::get);
-      BufferManager.initialized = true;
-   }
-   
+
    /**
     * Register this buffer as 'dirty' in the current scope.
     * <p>
@@ -821,7 +821,12 @@
     */
    public void registerDirtyBuffer(RecordBuffer recordBuffer)
    {
-      dirtyBuffers.addEntry(false, recordBuffer, false);
+      // although no state in BufferManager is touched when registering a dirty buffer, we need to register
+      // it with the current block, as there is logic dependent on the 'depth' of the application stack which
+      // uses buffers
+      registerScopeable(this);
+      
+      txWrapperHelper.registerDirtyBuffer(recordBuffer);
    }
    
    /**
@@ -912,127 +917,6 @@
    }
    
    /**
-    * A full transaction or sub-transaction is committing. Notify all dirty buffers in the current scope.
-    * 
-    * @param   transaction
-    *          {@code true} if full transaction; {@code false} if sub-transaction.
-    */
-   @Override
-   public void commit(boolean transaction)
-   {
-      Map<RecordBuffer, Boolean> buffers = dirtyBuffers.getDictionaryAtScope(0, false);
-      if (buffers != null && !buffers.isEmpty())
-      {
-         for (RecordBuffer buf : buffers.keySet())
-         {
-            buf.commit(transaction);
-         }
-         if (transaction)
-         {
-            buffers.clear();
-         }
-      }
-   }
-   
-   /**
-    * A full transaction or sub-transaction is rolling back. Notify all dirty buffers in the current scope.
-    * 
-    * @param   transaction
-    *          {@code true} if full transaction; {@code false} if sub-transaction.
-    */
-   @Override
-   public void rollback(boolean transaction)
-   {
-      Map<RecordBuffer, Boolean> buffers = dirtyBuffers.getDictionaryAtScope(0, false);
-      if (buffers != null && !buffers.isEmpty())
-      {
-         for (RecordBuffer buf : buffers.keySet())
-         {
-            buf.rollback(transaction);
-         }
-         if (transaction)
-         {
-            buffers.clear();
-         }
-      }
-   }
-
-   /**
-    * A block is exiting or iterating normally within a transaction. Notify all dirty buffers in the current
-    * scope.
-    * 
-    * @param   transaction
-    *          {@code true} if full transaction; {@code false} if sub-transaction.
-    * @param   aggressiveFlush
-    *          {@code true} if transaction manager is in aggressive subtransaction
-    *          flush mode, indicating that any transient buffers should be validated and
-    *          flushed, regardless of other state.
-    */
-   @Override
-   public void validate(boolean transaction, boolean aggressiveFlush)
-   {
-      TailMap<RecordBuffer, Boolean> buffers = dirtyBuffers.getDictionaryAtScope(0, false);
-      if (buffers != null && !buffers.isEmpty())
-      {
-         ArrayList<Map<RecordBuffer, Boolean>> validatedAddedDirtyBuffers = null;
-         try (AutoCloseable itersafe = buffers.flagIterating())
-         {
-            for (RecordBuffer buf : buffers.keySet())
-            {
-               buf.validate(transaction, aggressiveFlush);
-               
-               // The next block is rarely entered, only in edge cases.
-               // Details:
-               // The invocation of buf.validate can (for example) result in
-               // an ABL publish + subscribe (from an OEDB write trigger),
-               // resulting in more buffers that need to be validated.
-               // Since we are iterating, the extra buffers are added to
-               // a standalone 'tail' collection. We validate them immediately,
-               // and add them to dirtyBuffers after iterating has completed.
-               Map<RecordBuffer, Boolean> addedDirtyBuffers = buffers.pop();
-               while (addedDirtyBuffers != null)
-               {
-                  // Validate all additions
-                  addedDirtyBuffers.keySet().forEach((v) -> v.validate(transaction, aggressiveFlush));
-                  
-                  // Store the validated additions to add them afterwards
-                  // A list is used for clarity and to facilitate possible
-                  // removal logic in the future (which can't happen at the moment).
-                  if (validatedAddedDirtyBuffers == null)
-                  {
-                     validatedAddedDirtyBuffers = new ArrayList<>();
-                  }
-                  validatedAddedDirtyBuffers.add(addedDirtyBuffers);
-                  
-                  // Fetch possible new additions of the added validate invocations.
-                  // We take control of this collection, at the TailMap it
-                  // is forgotten.
-                  addedDirtyBuffers = buffers.pop();
-               }
-            }
-         }
-         catch (Exception e)
-         {
-            throw new IllegalStateException("Exception at dirtyBuffers.flagIterating block", e);
-         }
-         
-         // The next block is rarely entered, only in edge cases, see above.
-         if (validatedAddedDirtyBuffers != null)
-         {
-            for (Map<RecordBuffer, Boolean> bufmap : validatedAddedDirtyBuffers)
-            {
-               // Note: addEntry(false, ...) because:
-               //       We do not need the global scope.
-               //       At the top of this method, scope 0 is used, not scope -1 (global).
-               bufmap.forEach((k,v) -> dirtyBuffers.addEntry(false, k, v));
-            }
-         }
-         
-         // do not clear the buffers here, only commit/rollback can clear it
-      }
-   }
-   
-   /**
     * Query the scope level which currently is open. This is the number of &quot;important&quot; scopes;
     * NO_TRANSACTION blocks inside an application transaction are ignored. So, this number may be lower
     * than the actual number of nested block scopes open, as tracked by the {@code TransactionManager}.
@@ -1045,6 +929,27 @@
    }
    
    /**
+    * Find the nearest external block (from the bottom of the stack).
+    * 
+    * @return   See above.
+    */
+   public int findNearestExternal()
+   {
+      int idx = externalScope.size() - 1;
+      while (idx > 0)
+      {
+         if (externalScope.get(idx))
+         {
+            return idx + 1;
+         }
+         
+         idx = idx - 1;
+      }
+      
+      return -1;
+   }
+   
+   /**
     * Check the specified exception and determine whether we want to allow it
     * to be honored by the {@link TransactionManager}, or whether we want to
     * veto the STOP at this scope.
@@ -1107,56 +1012,7 @@
     */
    public void beginTx(boolean inTx, boolean fullTx, int blockDepth)
    {
-      if (inTx)
-      {
-         if (fullTx)
-         {
-            // create a database xaction wrapper for each connected database, but do not
-            // activate it yet
-            txWrapperMap.clear();         // should be empty already
-            inactiveTxWrappers.clear();   // should be empty already
-            List<Database> databases = connMgr.getActiveDatabases();
-            for (Database database : databases)
-            {
-               createTxWrapper(database);
-            }
-            
-            transactionDepth = blockDepth - 1;  // match TM transaction level
-            transactionCount++;
-            
-            // register for master transaction finish/iterate to clear transaction depth
-            txHelper.registerTransactionFinish(xactFin, true);
-         }
-         
-         // register various services for callbacks if current block has transaction properties
-         if (txHelper.currentTransactionLevel() != TransactionManager.NO_TRANSACTION)
-         {
-            // register savepoint manager for callbacks at full and sub-transaction blocks
-            for (TxWrapper txw : txWrapperMap.values())
-            {
-               txw.registerSavepointHooks(fullTx);
-            }
-            
-            // register to get Commitable notifications for open buffers
-            txHelper.registerCommitAt(blockDepth - 1, this);
-            
-            // register unique tracker context to get Commitable/Finalizable notifications
-            uniqueTrackerCtx.register(txHelper, blockDepth - 1);
-         }
-      }
-      
-      scopeTransitions++;
-      
-      if (fullTx)
-      {
-         // activate a pending TxWrapper for any database with a buffer that already is open
-         Iterator<Database> iter = activeDatabases.keySet().iterator();
-         while (iter.hasNext())
-         {
-            Database database = iter.next();
-            maybeActivateTxWrapper(database);
-         }
-      }
+      txWrapperHelper.beginTx(inTx, fullTx, blockDepth);
    }
    
    /**
@@ -1169,7 +1025,7 @@
     */
    public void endTx(boolean inTx, boolean fullTx)
    {
-      scopeTransitions++;
+      txWrapperHelper.endTx(inTx, fullTx);
    }
    
    /**
@@ -1178,7 +1034,7 @@
    public void endTxPost()
    {
       // if any DBs were used in this tx block and remained connected, disconnect now
-      connMgr.transactionEnded();
+      txWrapperHelper.endTxPost();
    }
    
    /**
@@ -1197,12 +1053,6 @@
    @Override
    public void scopeStart()
    {
-      if (!isImportantBlockTransition())
-      {
-         // nothing to do
-         return;
-      }
-      
       BlockType bt = txHelper.getBlockType();
       if (bt.equals(BlockType.INTERNAL_PROC) ||
           bt.equals(BlockType.FUNCTION)      ||
@@ -1228,13 +1078,10 @@
       
       allBuffers.addScope(null);
       byLegacyName.addScope(null);
-      loadedBuffers.addScope(null);
-      dirtyBuffers.addScope(null);
       openBuffers.pushScope();
       openStaticTempTables.addScope(null);
       thOutputParameters.addScope(null);
-      undoData.addScope(null);
-      fieldScopes.scopeStart();
+      externalScope.push(txHelper.isExternalBlock());
       
       BatchModeData crtBatchScope = batchModeStack.peek();
       if (crtBatchScope != null && crtBatchScope.batchDepth == BatchModeData.INTERNAL)
@@ -1287,11 +1134,6 @@
          LOG.log(Level.FINER,
                  Utils.describeContext() + ":  block scope " + blockDepth + " started");
       }
-      
-      boolean inTx = txHelper.isTransaction();
-      boolean fullTx = inTx && txHelper.isFullTransaction();
-      
-      beginTx(inTx, fullTx, blockDepth);
    }
    
    /**
@@ -1301,12 +1143,6 @@
    @Override
    public void scopeFinished()
    {
-      if (!isImportantBlockTransition())
-      {
-         // nothing to do
-         return;
-      }
-      
       PersistentProcScope ppScope = null;
       
       if (!txHelper.isGlobalBlock())
@@ -1327,76 +1163,10 @@
          }
       }
       
-      // here we will be out of sync with the TM on a transaction boundary, because our
-      // transaction depth is cleared with a transaction finalizable, which is called before this
-      // scope finished notification, so we rely on the TM.isTransaction() instead of our own
-      boolean inTx = txHelper.isTransaction();
-      boolean fullTx = txHelper.isFullTransaction();
-      
-      endTx(inTx, fullTx);
-      
-      Map<RecordBuffer, Boolean> dirtyBufs = dirtyBuffers.getDictionaryAtScope(0, false);
-      dirtyBuffers.deleteScope();
-      if (dirtyBufs != null && !dirtyBufs.isEmpty() && dirtyBuffers.size() > 1)
-      {
-         // do not merge into the global block, as all changes should have been already committed or rolled
-         // back.  this is required as temporary buffers can be changed without an active transaction present
-         // on the stack: in this case, they will be pushed to the previous scope until the global block is
-         // reached, when they will be discarded.
-         
-         for (RecordBuffer buffer : dirtyBufs.keySet())
-         {
-            // merge into previous scope, but only buffers with records which were changed, as the record 
-            // associated (at initial dirty registration of the buffer) may have been flushed to the database,
-            // and the current record may not be 'dirty'
-            if (buffer.getCurrentRecord() != null)
-            {
-               Record record = buffer.getCurrentRecord();
-               if (buffer.isTouched() || 
-                   record.checkState(DmoState.NEW)      ||
-                   record.checkState(DmoState.STALE)    ||
-                   record.checkState(DmoState.DELETING) ||
-                   record.checkState(DmoState.DELETED)  ||
-                   record.checkState(DmoState.INVALID)  ||
-                   record.checkState(DmoState.CHANGED)  ||
-                   record.checkState(DmoState.TRACKED))
-               {
-                  dirtyBuffers.addEntry(false, buffer, false);
-               }
-            }
-         }
-      }
-      undoData.deleteScope();
-      
-      // Copy the set of buffers contained in the current scope of the
-      // loadedBuffers (which is about to be removed) to the enclosing scope.
-      // Only buffers which are open at the enclosing or a higher scope
-      // should be copied.
-      if (loadedBuffers.size() > 1)
-      {
-         Set<RecordBuffer> currentLoadedBuffers = loadedBuffers.getDictionaryAtScope(0, false).keySet();
-         
-         Collection<RecordBuffer> currentOpenBuffers = openBuffers.sublistAtScope(0);
-         
-         for (RecordBuffer buffer : currentLoadedBuffers)
-         {
-            if (buffer.getOpenScopeCount() > 1 || !currentOpenBuffers.contains(buffer))
-            {
-               // if this buffer is missing at the current scope of open
-               // buffers or it presents there but has open scope count > 1,
-               // that means that it presents at a higher level and it should
-               // be copied to the enclosing scope
-               loadedBuffers.setValueAtScope(buffer, 1, false);
-               buffer.addLoadedBuffersScope(loadedBuffers.size() - 1);
-            }
-         }
-      }
       if (ppScope != null)
       {
          // save the data for this external procedure, as these will need to be removed from the
          // global scope, when the procedure gets deleted.
-         Map<RecordBuffer, Boolean> thisLoadedBuffers = loadedBuffers.getDictionaryAtScope(0, false);
-         ppScope.loadedBuffers.putAll(thisLoadedBuffers);
          
          List<RecordBuffer> thisOpenBuffers = openBuffers.sublistAtScope(0);
          ppScope.openBuffers.addAll(thisOpenBuffers);
@@ -1411,13 +1181,7 @@
          ppScope.openStaticTempTables.putAll(thisOpenStaticTempTables);
          
          // add all these to the global scope, too
-         
-         if (!thisLoadedBuffers.isEmpty())
-         {
-            loadedBuffers.getDictionaryAtScope(loadedBuffers.size() - 1, true)
-                         .putAll(thisLoadedBuffers);
-         }
-         
+
          if (!thisOpenBuffers.isEmpty())
          {
             openBuffers.addAll(true, thisOpenBuffers);
@@ -1448,13 +1212,12 @@
          }
       }
       
-      loadedBuffers.deleteScope();
       openBuffers.popScope();
       allBuffers.deleteScope();
       byLegacyName.deleteScope();
-      fieldScopes.scopeFinished();
       openStaticTempTables.deleteScope();
       thOutputParameters.deleteScope();
+      externalScope.pop();
       BatchModeData bmd = batchModeStack.pop();
       if (bmd.batchDepth == BatchModeData.INTERNAL)
       {
@@ -1467,11 +1230,6 @@
                  Utils.describeContext() + ":  block scope " + txHelper.getNestingLevel() + " finished");
       }
       
-      if (fullTx)
-      {
-         endTxPost();
-      }
-      
       maybeCloseSessions();
    }
    
@@ -1479,8 +1237,7 @@
     * Provides notification that the external procedure scope has been deleted.
     * <p>
     * If we are deleting a persistent procedure, clean all its data from the global scope for the
-    * following dictionaries: {@link #loadedBuffers}, {@link #openBuffers}, {@link #allBuffers}, 
-    * {@link #openStaticTempTables}.
+    * following dictionaries: {@link #openBuffers}, {@link #allBuffers}, {@link #openStaticTempTables}.
     */
    @Override
    public void scopeDeleted()
@@ -1502,13 +1259,6 @@
       {
          // remove all these from the global scope
          
-         if (!scope.loadedBuffers.isEmpty())
-         {
-            loadedBuffers.getDictionaryAtScope(loadedBuffers.size() - 1, true)
-                         .keySet()
-                         .removeAll(scope.loadedBuffers.keySet());
-         }
-         
          if (!scope.openBuffers.isEmpty())
          {
             openBuffers.removeAllFrom(true, scope.openBuffers);
@@ -1536,6 +1286,17 @@
    }
    
    /**
+    * Get the {@link ScopeId} for the instance.
+    * 
+    * @return   {@link ScopeId#BUFFER_MANAGER}.
+    */
+   @Override
+   public ScopeId getScopeId()
+   {
+      return ScopeId.BUFFER_MANAGER;
+   }
+   
+   /**
     * Provides a notification that a batch is starting or ending.  Enters or
     * exits batch assignment mode for all record buffers in this context,
     * depending on the value of <code>start</code>.
@@ -1560,42 +1321,6 @@
    }
    
    /**
-    * Releases the buffers into which a new record was loaded (or the old
-    * record was reloaded) into the current or deeper scopes, or only clears
-    * the list of buffers pending to be released.
-    *
-    * @param clearOnly
-    *        If <code>true</code> then clear the list of buffers pending to be
-    *        released, otherwise perform release of these buffers and clear
-    *        the list after that.
-    */
-   public void resetState(boolean clearOnly)
-   {
-      Map<RecordBuffer, Boolean> buffers = loadedBuffers.getDictionaryAtScope(0, false);
-      if (buffers == null || buffers.isEmpty())
-      {
-         return;
-      }
-      
-      if (!clearOnly)
-      {
-         for (RecordBuffer buffer : buffers.keySet())
-         {
-            if (!buffer.isPendingRollbackProcessed())
-            {
-               buffer.release(false, false);
-            }
-            else
-            {
-               buffer.resetPendingRollbackProcessed();
-            }
-         }
-      }
-      
-      buffers.clear();
-   }
-   
-   /**
     * Marks the table for postponed delete, if it is possible. Postponed delete can take place if
     * the table is used as [INPUT-]OUTPUT TABLE-HANDLE parameter.
     *
